"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _Input = require("./Input");

var TextArea = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2.default)(TextArea, _React$Component);

  function TextArea() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      value: _this.props.defaultValue
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "inputRef", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleKeyDown", function (e) {
      var _this$props = _this.props,
          onPressEnter = _this$props.onPressEnter,
          onKeyDown = _this$props.onKeyDown;

      if (e.keyCode === 13 && onPressEnter) {
        onPressEnter(e);
      }

      if (onKeyDown) {
        onKeyDown(e);
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleChange", function (e) {
      _this.setValue(e.target.value, e);
    });
    return _this;
  }

  TextArea.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, state) {
    return {
      value: nextProps.value === undefined ? state.value : nextProps.value
    };
  };

  var _proto = TextArea.prototype;

  _proto.focus = function focus() {
    var _this$inputRef$curren;

    (_this$inputRef$curren = this.inputRef.current) === null || _this$inputRef$curren === void 0 ? void 0 : _this$inputRef$curren.focus();
  };

  _proto.blur = function blur() {
    var _this$inputRef$curren2;

    (_this$inputRef$curren2 = this.inputRef.current) === null || _this$inputRef$curren2 === void 0 ? void 0 : _this$inputRef$curren2.blur();
  };

  _proto.select = function select() {
    var _this$inputRef$curren3;

    (_this$inputRef$curren3 = this.inputRef.current) === null || _this$inputRef$curren3 === void 0 ? void 0 : _this$inputRef$curren3.select();
  };

  _proto.setValue = function setValue(newValue, e, callback) {
    var _this$props2 = this.props,
        onChange = _this$props2.onChange,
        value = _this$props2.value;

    if (value === undefined) {
      this.setState({
        value: newValue
      }, callback);
    }

    if (onChange) {
      onChange(newValue, e);
    }
  };

  _proto.getInput = function getInput() {
    return this.inputRef.current;
  };

  _proto.render = function render() {
    var _classnames;

    var _this$props3 = this.props,
        prefixCls = _this$props3.prefixCls,
        className = _this$props3.className,
        disabled = _this$props3.disabled,
        readOnly = _this$props3.readOnly,
        onChange = _this$props3.onChange,
        restProps = (0, _objectWithoutProperties2.default)(_this$props3, ["prefixCls", "className", "disabled", "readOnly", "onChange"]);
    return /*#__PURE__*/_react.default.createElement("textarea", (0, _extends2.default)({}, restProps, {
      ref: this.inputRef,
      disabled: disabled,
      readOnly: readOnly,
      onChange: this.handleChange,
      onKeyDown: this.handleKeyDown,
      value: (0, _Input.fixControlledValue)(this.state.value),
      className: (0, _classnames2.default)(prefixCls, (_classnames = {}, _classnames[className] = className, _classnames[prefixCls + "-disabled"] = !!disabled, _classnames[prefixCls + "-readonly"] = !!readOnly, _classnames))
    }));
  };

  return TextArea;
}(_react.default.Component);

exports.default = TextArea;
(0, _defineProperty2.default)(TextArea, "defaultProps", {
  prefixCls: "rw-input",
  defaultValue: ""
});