import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from "react";
import classnames from "classnames";
import { fixControlledValue } from "./Input";

var TextArea = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(TextArea, _React$Component);

  function TextArea() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {
      value: _this.props.defaultValue
    });

    _defineProperty(_assertThisInitialized(_this), "inputRef", /*#__PURE__*/React.createRef());

    _defineProperty(_assertThisInitialized(_this), "handleKeyDown", function (e) {
      var _this$props = _this.props,
          onPressEnter = _this$props.onPressEnter,
          onKeyDown = _this$props.onKeyDown;

      if (e.keyCode === 13 && onPressEnter) {
        onPressEnter(e);
      }

      if (onKeyDown) {
        onKeyDown(e);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (e) {
      _this.setValue(e.target.value, e);
    });

    return _this;
  }

  TextArea.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, state) {
    return {
      value: nextProps.value === undefined ? state.value : nextProps.value
    };
  };

  var _proto = TextArea.prototype;

  _proto.focus = function focus() {
    var _this$inputRef$curren;

    (_this$inputRef$curren = this.inputRef.current) === null || _this$inputRef$curren === void 0 ? void 0 : _this$inputRef$curren.focus();
  };

  _proto.blur = function blur() {
    var _this$inputRef$curren2;

    (_this$inputRef$curren2 = this.inputRef.current) === null || _this$inputRef$curren2 === void 0 ? void 0 : _this$inputRef$curren2.blur();
  };

  _proto.select = function select() {
    var _this$inputRef$curren3;

    (_this$inputRef$curren3 = this.inputRef.current) === null || _this$inputRef$curren3 === void 0 ? void 0 : _this$inputRef$curren3.select();
  };

  _proto.setValue = function setValue(newValue, e, callback) {
    var _this$props2 = this.props,
        onChange = _this$props2.onChange,
        value = _this$props2.value;

    if (value === undefined) {
      this.setState({
        value: newValue
      }, callback);
    }

    if (onChange) {
      onChange(newValue, e);
    }
  };

  _proto.getInput = function getInput() {
    return this.inputRef.current;
  };

  _proto.render = function render() {
    var _classnames;

    var _this$props3 = this.props,
        prefixCls = _this$props3.prefixCls,
        className = _this$props3.className,
        disabled = _this$props3.disabled,
        readOnly = _this$props3.readOnly,
        onChange = _this$props3.onChange,
        restProps = _objectWithoutProperties(_this$props3, ["prefixCls", "className", "disabled", "readOnly", "onChange"]);

    return /*#__PURE__*/React.createElement("textarea", _extends({}, restProps, {
      ref: this.inputRef,
      disabled: disabled,
      readOnly: readOnly,
      onChange: this.handleChange,
      onKeyDown: this.handleKeyDown,
      value: fixControlledValue(this.state.value),
      className: classnames(prefixCls, (_classnames = {}, _classnames[className] = className, _classnames[prefixCls + "-disabled"] = !!disabled, _classnames[prefixCls + "-readonly"] = !!readOnly, _classnames))
    }));
  };

  return TextArea;
}(React.Component);

_defineProperty(TextArea, "defaultProps", {
  prefixCls: "rw-input",
  defaultValue: ""
});

export { TextArea as default };