import React from "react";
export interface TextAreaProps extends Omit<React.TextareaHTMLAttributes<HTMLTextAreaElement>, "onChange"> {
    prefixCls?: string;
    onChange?: (value: string, e: React.SyntheticEvent) => void;
    onPressEnter?: (e: React.KeyboardEvent<HTMLTextAreaElement>) => void;
}
export interface TextAreaState {
    value: TextAreaProps["value"];
}
export default class TextArea extends React.Component<TextAreaProps> {
    static defaultProps: TextAreaProps;
    static getDerivedStateFromProps(nextProps: TextAreaProps, state: TextAreaState): {
        value: string | number | string[] | undefined;
    };
    state: Readonly<TextAreaState>;
    inputRef: React.RefObject<HTMLTextAreaElement>;
    focus(): void;
    blur(): void;
    select(): void;
    handleKeyDown: (e: React.KeyboardEvent<HTMLTextAreaElement>) => void;
    handleChange: (e: React.ChangeEvent<HTMLTextAreaElement>) => void;
    setValue(newValue: string, e: React.SyntheticEvent, callback?: () => void): void;
    getInput(): HTMLTextAreaElement;
    render(): JSX.Element;
}
